

#define _USE_BINK


// the implementation is in this file
#include "StandardParameters.fxh"
#include "Effect_common.fxh"

///////////////////////////////////////////////////////////////////////////////

 struct binkVertexInput
 {                                                     
    float4 pPosition : POSITION; 
	float4 cDiffuse	 : COLOR;
    float4 tcDiffuse : TEXCOORD0;                                  
 };
 
 struct binkVertexOutput                        
 {               
 	float4 pPosition 	: POSITION;                      
    float2 tcDiffuse0	: TEXCOORD0;
    float2 tcDiffuse1	: TEXCOORD1;
    float2 tcDiffuse2	: TEXCOORD2;
 };                                                
                                                       
 binkVertexOutput VS_BinkConversion( binkVertexInput IN )                            
 {            
 	binkVertexOutput OUT;
 	
 	OUT.pPosition = IN.pPosition;
 	OUT.tcDiffuse0 = IN.tcDiffuse;
 	OUT.tcDiffuse1 = IN.tcDiffuse;
 	OUT.tcDiffuse2 = IN.tcDiffuse;
 	                                          
    return OUT;                                        
 }                                                     

///////////////////////////////////////////////////////////////////////////////

float4 PS_BinkConversion( binkVertexOutput IN ) : COLOR      
{                                     
   float4 c;                           
   float4 p;                           
   c.x = tex2D( g_sampBinkLume, IN.tcDiffuse0 ).x; 
   c.y = tex2D( g_sampBinkChR, IN.tcDiffuse1 ).x;       
   c.z = tex2D( g_sampBinkChB, IN.tcDiffuse2 ).x;       
   c.w = g_vBinkConstants.x;                    
   p.x = dot( g_vBinkToR, c );                
   p.y = dot( g_vBinkToG, c );                
   p.z = dot( g_vBinkToB, c );                
   p.w = g_vBinkConstants.w;                     
   return p;                           
 }
 
 ///////////////////////////////////////////////////////////////////////////////

technique BinkConversion
<
// this value must exactly match the enum value of
// Mad3D_VertexFormats::eFormat
string Mad3D_VertexFormat = "kPosRHWColorTex1";
// this is used by the game to choose an effect based on user setting
// lower value = less quality & more speed
int Quality = QUALITY_DEFAULT;
// the number of lights the effect can do
int SupportedLightsMin = 0;
int SupportedLightsMax = 8;
>
{
    pass BasePass
    <
    // this annotation tells the Mad3D_Renderer that this is the base pass to use only once
    bool	bBasePass = true;
    >
    {
		VertexShader = compile vs_3_0 VS_BinkConversion();
		PixelShader  = compile ps_3_0 PS_BinkConversion();
    }
}

// no bink as a fallback ...
technique BinkConversionFallback
<
// this value must exactly match the enum value of
// Mad3D_VertexFormats::eFormat
string Mad3D_VertexFormat = "kPosRHWColorTex1";
// this is used by the game to choose an effect based on user setting
// lower value = less quality & more speed
int Quality = QUALITY_LASTRESORT;
// the number of lights the effect can do
int SupportedLightsMin = 0;
int SupportedLightsMax = 8;
>
{
}
