#define _USE_CLOAKING
#include "diffusebump.fxh"


///////////////////////////////////////////////////////////////////////////////

// Bump mapping with just diffuse information
technique DiffuseBump
<
// this value must exactly match the enum value of
// Mad3D_VertexFormats::eFormat
string Mad3D_VertexFormat = "kPosNormTex1ST";
// this is used by the game to choose an effect based on user setting
// lower value = less quality & more speed
int Quality = QUALITY_DEFAULT;
// the number of lights the effect can do
int SupportedLightsMin = 0;
int SupportedLightsMax = 8;
>
{
   pass ShadowPass
    <
    // this annotation tells the Mad3D_Renderer that this is the base pass to use only once
    bool	bShadowPass = true;
    >
    {
		VertexShader = compile vs_3_0 VS_BumpDiffuse((g_pBasePassLightPosition) , (g_cBasePassLightColor), true);
		PixelShader  = compile ps_3_0 PS_BumpDiffuse((g_cBasePassLightColor), (g_cMaterialDiffuse), (g_cMaterialAmbient), true);
    }
    pass BasePass
	<
    	// tell the mad3D engine that this is the base pass 
    	// to do once
    	bool bBasePass = true;
	>
    {
		VertexShader = compile vs_3_0 VS_BumpDiffuse( (g_pBasePassLightPosition) , (g_cBasePassLightColor), false );
		PixelShader  = compile ps_3_0 PS_BumpDiffuse( (g_cBasePassLightColor), (g_cMaterialDiffuse), (g_cMaterialAmbient), false );
    }
	pass PerLightPass
	<
	// tell the mad3D engine pass to call once for every light while changing the value 
	// of the g_vLightColor & g_vLightPosition parameters
	bool bPerLightPass = true;
	>
    {
    	AlphaBlendEnable = true;
		DestBlend = one;
		VertexShader = compile vs_3_0 VS_BumpDiffuse( (g_pPerLightPassLightPosition) , (g_cPerLightPassLightColor), false );
		PixelShader  = compile ps_3_0 PS_BumpDiffuse( (g_cPerLightPassLightColor), (g_cMaterialDiffuse), float3( 0,0,0 ), false );
    }
}

// Bump mapping with just diffuse information
technique DiffuseBump
<
// this value must exactly match the enum value of
// Mad3D_VertexFormats::eFormat
string Mad3D_VertexFormat = "kPosNormTex1ST";
// this is used by the game to choose an effect based on user setting
// lower value = less quality & more speed
int Quality = QUALITY_LOW;
// the number of lights the effect can do
int SupportedLightsMin = 0;
int SupportedLightsMax = 8;
>
{
   pass ShadowPass
    <
    // this annotation tells the Mad3D_Renderer that this is the base pass to use only once
    bool	bShadowPass = true;
    >
    {
		VertexShader = compile vs_3_0 VS_BumpDiffuse((g_pBasePassLightPosition) , (g_cBasePassLightColor), false);
		PixelShader  = compile ps_3_0 PS_BumpDiffuse((g_cBasePassLightColor), (g_cMaterialDiffuse), (g_cMaterialAmbient), false);
    }
    pass BasePass
	<
    	// tell the mad3D engine that this is the base pass 
    	// to do once
    	bool bBasePass = true;
	>
    {
		VertexShader = compile vs_3_0 VS_BumpDiffuse( (g_pBasePassLightPosition) , (g_cBasePassLightColor), false );
		PixelShader  = compile ps_3_0 PS_BumpDiffuse( (g_cBasePassLightColor), (g_cMaterialDiffuse), (g_cMaterialAmbient), false );
    }
	pass PerLightPass
	<
	// tell the mad3D engine pass to call once for every light while changing the value 
	// of the g_vLightColor & g_vLightPosition parameters
	bool bPerLightPass = true;
	>
    {
    	AlphaBlendEnable = true;
		DestBlend = one;
		VertexShader = compile vs_3_0 VS_BumpDiffuse( (g_pPerLightPassLightPosition) , (g_cPerLightPassLightColor), false );
		PixelShader  = compile ps_3_0 PS_BumpDiffuse( (g_cPerLightPassLightColor), (g_cMaterialDiffuse), float3( 0,0,0 ), false );
    }
}
///////////////////////////////////////////////////////////////////////////////

// Default lighting.
#include "FixedPipelineDiffuse.fxh"

///////////////////////////////////////////////////////////////////////////////

